
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>动态规划——最长上升子序列 / 憋错料</title>

    <meta name="description" content="动态规划——最长上升子序列 问题 最长上升子序列是一类经典的动态规划问题. 给定N个数字, A1,A2,....An,从中选择k个数字 At1, At2,... Atk,满足 1 =&lt; t1 &lt; t2 &lt; .. &lt; tk &lt;= n,且 At1 &lt; At2 &lt; ... &lt; Atk,求满足要求的最大的k. 分析 设一个动归数组dp,dp[i]表示以第i个数字(即Ai)结尾的最长上升子序列的长度,显然这种问题的划分满足无后效性和最优子结构.同时,可以很方便的推出递推关系 dp[i] ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">动态规划——最长上升子序列</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h4><strong>问题</strong></h4>
<p>最长上升子序列是一类经典的动态规划问题。</p>
<blockquote><p>给定N个数字, A1,A2,....An，从中选择k个数字 At1, At2,... Atk，满足 1 =&lt; t1 &lt; t2 &lt; .. &lt; tk &lt;= n，且 At1 &lt; At2 &lt; ... &lt; Atk，求满足要求的最大的k。</p></blockquote>
<h4><strong>分析</strong></h4>
<p>设一个动归数组dp，dp[i]表示以第i个数字（即Ai）结尾的最长上升子序列的长度，显然这种问题的划分满足无后效性和最优子结构。同时，可以很方便的推出递推关系&nbsp;<br />dp[i] = max{1, dp[j] +1} （j &lt; i 且 Ai &gt; Aj)</p>
<h4><strong>实现</strong></h4>

<pre>memset(dp, 0, sizeof(dp));
for(int i = 1; i &lt;= n; i ++){ //数组从1开始
    int max = 0;
    for(int j = 1; j &lt; i; j ++){
        if(A[i] &gt; A[j] &amp;&amp; dp[j] &gt; max)
            max = dp[j];
    }
    dp[i] = max + 1;
}
</pre>

<h4><strong>复杂度分析</strong></h4>
<p>显然，时间复杂度为O(n^2), 空间复杂度为O(n). 其实还存在一种时间复杂度为O(n*logn)的算法，利用二分查找优化，比较复杂，就没仔细看。。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-24 18:01:29 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>动态规划——最长上升子序列的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6emxN4.html" rel="bookmark">uva 11400 - Lighting System Design（动态规划 最长上升子序列问题变型）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本题难处好像是在于 可以把一些灯泡换成电压更高的灯泡以节省电源的钱 ,所以也才有了对最优方案的探求 好的处理方法是按照电压从小到大排序,只能让前面的换成后面的,也就满足了把一些灯泡换成电压更高的灯泡 的要求: 一种电压的灯泡,要么不换,要换则应该全换:换,说明用当前的电源不值:而既然不值则应该全部换掉以避免使用当前电源,不然即增加了灯泡费用又没节省电源费用,亏大了... 状态转移详见代码 #include&lt;cstdio&gt; #include&lt;cstring&gt; #include&lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/kMLyKB0.html" rel="bookmark">动态规划-最长公共子序列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(1).问题描述:给出2个序列,x是从1到m,y是从1到n,找出x和y的最长公共子序列? x:A B C B D A B y:B D C A B A 则:最长公共子序列长度为4,BDAB BCAB BCBA均为LCS(最长公共子序列): 模型实现图: (2).问题解决 代码实现了最长公共子序列的长度 #include&lt;stdio.h&gt; #define N    10 int LCS(int *a, int count1, int *b, int count2); int LCS(int *a,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wryyZ0.html" rel="bookmark">动态规划 - 最长公共子序列（LCS）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最长公共子序列也是动态规划中的一个经典问题. 有两个字符串 S1 和 S2,求一个最长公共子串,即求字符串 S3,它同时为 S1 和 S2 的子串,且要求它的长度最长,并确定这个长度.这个问题被我们称为 最长公共子序列问题. 与求最长递增子序列一样,我们首先将原问题分割成一些子问题,我们用 dp[i][j]表示 S1 中前 i 个字符与 S2 中前 j 个字符分别组成的两个前缀字符串的最 长公共子串长度. 显然的,当 i. j 较小时我们可以直接得出答案,如 dp[0][j]必 等于 0.那么,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NJNNo4.html" rel="bookmark">动态规划---最长上升子序列问题（O&lpar;nlogn&rpar;&comma;O&lpar;n&Hat;2&rpar;）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				LIS(Longest Increasing Subsequence)最长上升子序列 或者 最长不下降子序列.很基础的题目,有两种算法,复杂度分别为O(n*logn)和O(n^2) . ********************************************************************************* 先回顾经典的O(n^2)的动态规划算法: 设a[t]表示序列中的第t个数,dp[t]表示从1到t这一段中以t结尾的最长上升子序列的长度,初始时设dp[			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YYyBX0.html" rel="bookmark">nlog&lpar;n&rpar;解动态规划--最长上升子序列&lpar;Longest increasing subsequence&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最长上升子序列LIS问题属于动态规划的初级问题,用纯动态规划的方法来求解的时间复杂度是O(n^2).但是如果加上二叉搜索的方法,那么时间复杂度可以降到nlog(n).  具体分析参考:http://blog.chinaunix.net/uid-26548237-id-3757779.html 代码: #include &lt;iostream&gt; using namespace std; int LIS_nlogn(int *arr, int len) { int *LIS = new int[len			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rvby73.html" rel="bookmark">动态规划 - 最长上升子序列问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文  http://xuanwo.org/2015/07/31/dp-lis/ 主题 动态规划 介绍 最长上升子序列问题,也就是 Longest increasing subsequence ,缩写为LIS .是指在一个序列中求长度最长的一个上升子序列的问题,是动态规划中一个相当经典问题.在这里我们可以看到,这个上升实质上就是一个对 &lt; 进行定义的过程,所以我们求解的其实是一类问题,也就是在给定序列中求解长度最长的符合某一性质的子序列的问题.在下面总结的过程中,我还是以递增为例进行阐述. O(			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPXd2vM.html" rel="bookmark">动态规划&mdash;&mdash;最长公共子序列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最长公共子序列(LCS)是一类典型的动归问题. 问题 给定两个序列(整数序列或者字符串)A和B,序列的子序列定义为从序列中按照索引单调增加的顺序取出若干个元素得到的新的序列,比如从序列A中取出 A[i1], A[i2], ...A[ik],其中0=&lt; i1 &lt;= i2 &lt;= ... ik &lt;= n-1得到的新的序列 A[i1].A[i2]....A[ik]即为A的一个子序列.     两个不同的原序列A和B可能有着相同的子序列,求出A和B的公共子序列的最长长度. 分析     这种			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0l9bBW3.html" rel="bookmark">《算法导论》读书笔记之动态规划&mdash;最长公共子序列 &amp;amp&semi; 最长公共子串（LCS）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				From:http://my.oschina.net/leejun2005/blog/117167 1.先科普下最长公共子序列 &amp; 最长公共子串的区别: 找两个字符串的最长公共子串,这个子串要求在原字符串中是连续的.而最长公共子序列则并不要求连续. 2.最长公共子串 其实这是一个序贯决策问题,可以用动态规划来求解.我们采用一个二维矩阵来记录中间的结果.这个二维矩阵怎么构造呢?直接举个例子吧:&quot;bab&quot;和&quot;caba&quot;(当然我们现在一眼就可以看出来最长公共子串是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLpYnEM.html" rel="bookmark">算法系列笔记6&lpar;动态规划&mdash;最长公共子序列&sol;串lcs&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				子序列要求元素顺序一致就可以了,而字串必须是连续的.如ABCBDAB与BDCABA两个字符串,最长公共子序列有BCBA.BDAB和BCAB, 而最长公共字串只有AB和BD&lt;连续&gt;.当然这里的求解只求一个,但通常是这样直接说求最长公共子串,子序列,准确的应该是之一. 最长公共子序列 法一:穷举法 检查字符串x所有字序列,共有2^m个,检查它是否在y字符串中出现,每个需要O(n),时间复杂度为指数级的. 法二:动态规划(DP) 将两个字符串x[1-m]和y[1-n]放在x轴和y轴方向上便得到一个二			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r4Jy1D3.html" rel="bookmark" class="title">浏览器插件研究</a>
					<div>
						很早就想开发浏览器插件,像谷歌浏览器插件太丰富,但要熟悉javesript,go语言. 一般的Web应用对于浏览器插件能不使用的建议尽量不使用,因为其涉及到安全问题以及影响用户安装(或自动下载注册安装 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/7MVaZk4.html" rel="bookmark" class="title">巧用Mysqlbinlog恢复数据库数据</a>
					<div>
						关于binlog的详解请参考:http://zlyang.blog.51cto.com/1196234/1833062 binlog日志用于记录所有更新了数据或者已经潜在更新了数据的所有语句.语句以& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWy9Gb3.html" rel="bookmark" class="title">Net框架下-ORM框架LLBLGen的简介（转载）</a>
					<div>
						Net框架下-ORM框架LLBLGen的简介 http://www.cnblogs.com/huashanlin/archive/2015/02/12/4288522.html 官方网址:http:/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3O7YbZ3.html" rel="bookmark" class="title">Test 2015&period;6&period;25 集训 Day1</a>
					<div>
						三题五小时 T1 正解:树链剖分或LCT,然而并听不太懂 考试时写了个树形DP+各种想办法优化,然而并没有什么卵用,和暴力分一样高 T2 正解:后缀和计数+贪心 主要写T1,T3去了,写了n^3暴力走 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M61pBW4.html" rel="bookmark" class="title">&lbrack;JAVA设计模式&rsqb;第二部分：创建模式</a>
					<div>
						声明:原创作品,转载时请注明文章来自SAP师太博客,并以超链接形式标明文章原始出处,否则将追究法律责任! 创建模式... 37					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KBLRwM.html" rel="bookmark" class="title">redis集群配置</a>
					<div>
						客户端分片 程序端实现 代理proxy,访问proxy,proxy指定redis保存位置. Twemproxy Redis cluster ,会造成一部分数据丢失,无中心化1.将数据自动切分(spli ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35Ab7j3.html" rel="bookmark" class="title">右旋 函数</a>
					<div>
						题目:输入一个字符串,将其进行右旋,如输入&quot;abcdef&quot;,右旋二个将得到&quot;efabcd&quot;,此题有多种解法,这里介绍两种常用的 字符右旋实现:(1)三步反转法: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODle84.html" rel="bookmark" class="title">linux下jetty中文乱码问题解决</a>
					<div>
						参考资料 http://stackoverflow.com/questions/4214111/jetty-character-encoding-issue 在startup.sh中,第一行加入 ex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KOARw0.html" rel="bookmark" class="title">&lbrack;sharepoint&rsqb;根据用户名获取该用户的权限</a>
					<div>
						写在前面 这样的一个场景,客户端请求sharepoint的rest api,但不允许传输用户的密码,使用的是证书认证的方式,但这样所有的用户用的是同一个证书,这样造成的结果就是无法识别该用户是否有操作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZbWLL3.html" rel="bookmark" class="title">unity&comma; 替换shader渲染（Rendering with Replaced Shaders）</a>
					<div>
						实现特效,尤其是一些后处理特效,经常需要将各物体的shader替换为另一套shader进行渲染到纹理,再后再进行合成或以某种叠加方式叠加到最后的画面上去. 再复杂一点儿的,可能不同的物体所用的替换sh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDrPY73.html" rel="bookmark" class="title">Linux设备驱动探究第1天----spi驱动（1）</a>
					<div>
						本文允许转载,请注明出处:http://blog.csdn.net/fulinus Linux内核代码实在太大了,一个小小的模块也会让你手足无措,今天下午决心要把spi驱动好好看看. 首先分析spid ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MymDOjM.html" rel="bookmark" class="title">【Vegas原创】SQL Server 只安装客户端的方法</a>
					<div>
						只安装管理工具					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pLoVy4.html" rel="bookmark" class="title">HTML5&plus;MUI&plus;HBuilder 之初探情人</a>
					<div>
						07,08年那会儿正当Java火爆,C/C++仍是广泛运用的一门语言的时候,所以我的大学都献给了C/C++和Java.当诺基亚的倒闭成为按键机时代衰落的标志时,移动APP的开发也如破堤之洪,爆炸式的崛 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPvmAa3.html" rel="bookmark" class="title">FFMPEG之协议&lpar;文件&rpar;操作----AVIOContext&comma; URLContext&comma; URLProtocol</a>
					<div>
						版权声明:本文为博主原创文章,未经博主允许不得转载. 协议操作对象结构: 协议(文件)操作的顶层结构是AVIOContext,这个对象实现了带缓冲的读写操作:FFMPEG的输入对象AVFormat的p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49eN5J4.html" rel="bookmark" class="title">SpringMVC 之URL请求到Action的映射（1）</a>
					<div>
						URL路径映射 1.1.对一个action配置多个URL映射: @RequestMapping(value={&quot;/index&quot;, &quot;/hello&quot;}, meth ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lN27p4.html" rel="bookmark" class="title">数组与数组能否直接赋值</a>
					<div>
						数组之间是不可以直接赋值的,要直接赋值的话,也只能是利用循环,一个一个的赋值,不过你所要实现的可以通过其他方法来实现,比如取地址运算,把数组a的首地址赋给B数组,不过这要通过指针来实现,还有一种简单点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vBlEk3.html" rel="bookmark" class="title">IIS 网站发布&mdash;&mdash;遇到的问题，以及解决方案</a>
					<div>
						在 解决方案——Web 右键  发布 如图: 之后,在其他文件夹或盘  放入发布之后 生成的文件 如图所示,之所以这样是为了好整理查找发布的项目. 之后,在IIS 上发布出去 首先  打开 控制面板— ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RmNWvM.html" rel="bookmark" class="title">css 固定宽高比容器</a>
					<div>
						申明: 本文参考 结一老师的文章 css中如何做到容器按比例缩放 核心思想: 给目标元素设置一个容器,设置高度为0,用垂直padding(百分比)来撑开高度,因为padding设置百分比时是基于容器的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myo1DE3.html" rel="bookmark" class="title">linux glibc 升级至glibc-2&period;14</a>
					<div>
						glibc是GNU发布的libc库,即c运行库.glibc是linux系统中最底层的api,几乎其它任何运行库都会依赖于glibc.glibc除了封装linux操作系统所提供的系统服务外,它本身也提供 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0klrJp3.html" rel="bookmark" class="title">设计模式-策略模式&lpar;Go语言描写叙述&rpar;</a>
					<div>
						好久没有更新博客了.近期也是在忙着充电,今天这篇博客開始,我们来了解一下设计模式. 设计模式 那什么是设计模式呢?首先来看看我从百科上copy下来的概念吧. 设计模式/软件设计模式(Design pa ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
